//  ChainBuilderMW.m
//  KnightsAndSpies

//updated 2009 to bail out as soon as we have reached someone who must be a knight
//so now we need to keep track of the acceptance threshhold, l

#import "ChainBuilderMW.h"


@implementation ChainBuilderMW


-(ChainBuilderMW*) initWithMW: (Crowd*) givenCrowd acceptingAt: (int) givenl;
{
    self = [super init];
    crowd = givenCrowd; //Not copied
    weights = [[NSMutableArray alloc] init];
    int i; for (i=0;i<[crowd numberOfPeople];i++) {
        [weights addObject: [NSNumber numberWithInt: 1]];
    }
    //NSLog(@"initWithCrowd in chainBuilder here, just set weights = %@",weights);
    //NSLog(@"crowd = %@",crowd);[crowd showMembers];
	l = givenl;
    return self;
}

-(NSDictionary*) buildChains
{
    //NSLog(@"buildChains here");
    NSMutableArray* allChains = [[NSMutableArray alloc] init];

    NSMutableArray* peopleToConsider = [[NSMutableArray alloc] init];
    int i; for (i=0;i<[crowd numberOfPeople];i++) {
        [peopleToConsider addObject: [NSNumber numberWithInt: i]];
    }
	
    while (TRUE) {
        NSDictionary* chainResults = [self buildChainsConsidering: peopleToConsider];
			//in new version, will return a triple: chains @"chains", finished @"finished", finalKnight, which is never void if finished holds
		NSMutableArray* chains = [chainResults objectForKey: @"chains"];
		NSNumber* finalKnight =  [chainResults objectForKey: @"finalKnight"];
		[chains sortUsingFunction: compareLengthsOfTaggedChains context: nil];
	    //NSLog(@"sorted chains = %@",chains);

		[allChains addObject: chains];
		
		if ([finalKnight intValue] > -1) {
			//NSLog(@"Reached a guaranteed knight, namely %@",finalKnight);
			//NSLog(@"Sorted chains just built are %@",chains);
			//NSLog(@"All chains are %@",allChains);
			NSDictionary* results = [NSDictionary dictionaryWithObjectsAndKeys: allChains, @"allChains",
																			    finalKnight, @"finalKnight",nil]; //note nil is essential
			return results;
		}

        [peopleToConsider release];
        peopleToConsider = [self finalKnights: chains];
    }
}

-(NSDictionary*) buildChainsConsidering: (NSMutableArray*) peopleToConsider
{
    //NSLog(@"buildChainsConsidering: %@",peopleToConsider);
    NSMutableArray* chains = [[NSMutableArray alloc] init];
    BOOL peopleFinished = FALSE; int i = 0;
    while (peopleFinished == FALSE)
    {
        TaggedChain* taggedChain = [[TaggedChain alloc] init];
        NSMutableArray* chain = [taggedChain chain];

        [chains addObject: taggedChain];
        [taggedChain setEndsWithSpy: FALSE];
        int finalKnight = -1; int spy = -1;
		int chainLength = 0;

        BOOL chainFinished = FALSE;
        while (chainFinished == FALSE)
        {
            //NSLog(@"i=%i",i);
            [chain addObject: [peopleToConsider objectAtIndex: i]];
			chainLength +=1;
			//NSLog(@"chain = %@, i = %i, chainLength = %i",chain,i,chainLength);
            if ((i == [peopleToConsider count]-1) || (chainLength > l)) {   //bail out if the chain is now long enough
                chainFinished = TRUE; peopleFinished = TRUE;
            }
            else {
                //NSLog(@"Considering whether to extend chain to another knight");
                int currentPerson = [[peopleToConsider objectAtIndex: i] intValue];
                int nextPerson = [[peopleToConsider objectAtIndex: i+1] intValue];
                //NSLog(@"currentPerson = %i, nextPerson = %i",currentPerson,nextPerson);
                BOOL claimsNextPersonIsKnight =
                    ([[[crowd person: currentPerson] viewOnPerson: nextPerson] intValue] == KNIGHT);
                if (claimsNextPersonIsKnight) i = i+1; else chainFinished = TRUE;
            }
        }
        
		if ((peopleFinished == FALSE) && (chainLength <= l)) { //don't want to add someone if there are still people left, but the chain is long enough
            [chain addObject: [peopleToConsider objectAtIndex: i+1]];
            spy = [[peopleToConsider objectAtIndex: i+1] intValue];
            [taggedChain setEndsWithSpy: TRUE];
        }
		
        if (i+1 == [peopleToConsider count]-1)
            peopleFinished = TRUE;

	    //we also pretend peopleFinished if we want to stop because the chain is long enough
		if (chainLength > l) {
			//NSLog(@"pretending that people are finished");
			peopleFinished = TRUE;
		}

        //The chain is now complete.
        //NSLog(@"Finished building chain %@",taggedChain);
        finalKnight = [[peopleToConsider objectAtIndex: i] intValue]; //nb this is the number of the knight, not a pointer to the knight
        //NSLog(@"finalKnight = %i, spy = %i",finalKnight,spy);
        //NSLog(@"At the moment, weights are %@",weights);

        int ll = [chain count] - (([taggedChain endsWithSpy]) ? 1 : 0);
        //NSLog(@"Chain of knightlength ll = %i",ll);
        //so the chain has the form K ... K S where there are ll Ks

        //Now walk along it, assigning weights to the claimed knights
        int oldWeight = 0; int newWeight = 0; int person;
        int j; for (j=0;j<ll;j++) {
            //NSLog(@"j = %i",j);
            person = [[chain objectAtIndex: j] intValue];
            //NSLog(@"At person %i",person);
            newWeight = [[weights objectAtIndex: person] intValue] + oldWeight;
            //NSLog(@"newWeight = %i",newWeight);
            [weights replaceObjectAtIndex: person
                               withObject: [NSNumber numberWithInt: newWeight]];
            //NSLog(@"Now person %i has weight %i",person,newWeight);
            oldWeight = newWeight;
        }

        //Finally subtract off the weight of the final claimed spy from everyone, including the spy
        //we subtract 0 if the chain ends in a knight
        int spiesWeight = ([taggedChain endsWithSpy]) ? [[weights objectAtIndex: spy] intValue] : 0;
        //NSLog(@"spiesWeight = %i",spiesWeight);
        for (j=0;j<[chain count];j++) {
            person = [[chain objectAtIndex: j] intValue];
            oldWeight = [[weights objectAtIndex: person] intValue];
            newWeight = oldWeight - spiesWeight;
            [weights replaceObjectAtIndex: person
                               withObject: [NSNumber numberWithInt: newWeight]];
            //NSLog(@"Now person %i has weight %i",person,newWeight);
        }
		
		//and we reduce the threshhold by the same amount
		l = l - spiesWeight;
		//NSLog(@"Threshold is now %i",l);

        int chainWeight = [[weights objectAtIndex: finalKnight] intValue];
        //the chain gets the biggest weight of the things in it
        [taggedChain setWeight: chainWeight];
		
		//nb, we always build a full chain before seeing if we've reached a knight
		if (chainWeight > l) {
			//NSLog(@"Chain just built, namely %@, must end in a knight",taggedChain);
			//NSLog(@"Test");
			//NSLog(@"About to build a dictionary with chains = %@, finalKnight = %@",chains,[NSNumber numberWithInt: finalKnight]);
			NSDictionary* results = [NSDictionary dictionaryWithObjectsAndKeys: chains, @"chains",
											     [NSNumber numberWithInt: finalKnight], @"finalKnight",nil]; //note nil is essential
			//NSLog(@"results = %@",results);
			return results;
		}
        //NSLog(@"Just set weight of chain %@",taggedChain);
        //NSLog(@"i = %i",i);
        //increment i and start a new chain off
        i = i+2;
    }

	//we've built some chains but haven't reached  a final knight
	return [NSDictionary dictionaryWithObjectsAndKeys: chains, @"chains",
													   [NSNumber numberWithInt: -1],@"finalKnight",nil]; //note nil is essential
}

-(NSMutableArray*) finalKnights: (NSMutableArray*) chains
{
    NSMutableArray* finalKnights = [[NSMutableArray alloc] init];
    int numberOfChains = [chains count];
    int i; for (i=0;i<numberOfChains;i++) {
        //NSLog(@"i = %i",i);
        TaggedChain *currentTaggedChain = [chains objectAtIndex: i];
        int j = [[currentTaggedChain chain] count];
        j = ([currentTaggedChain endsWithSpy]) ? j-2 : j-1;
        if ([currentTaggedChain weight] > 0)
            [finalKnights addObject: [[currentTaggedChain chain] objectAtIndex: j]];
        //NSLog(@"so far, penultimateMembers = %@",penultimateMembers);
    }
    return finalKnights;
}

int compareLengthsOfTaggedChains (id first, id second, void* context)
{
    int firstWeight = [first weight];
    int secondWeight = [second weight];
    if (firstWeight < secondWeight) return NSOrderedDescending; else {
        if (firstWeight > secondWeight) return NSOrderedAscending; else {
            return NSOrderedSame;
        }
    }
}

@end
