//  ChainResolver.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>
#import "Crowd.h"
#import "TaggedChain.h"

@interface ChainResolver : NSObject {
    Crowd* crowd;
    NSMutableArray* allChains; //note this is an array of array of chains
    NSMutableArray* identities;
    Person* knight;
}
-(ChainResolver*) initWith: (Crowd*) crowd allChains: (NSMutableArray*) allChains knight: (Person*) givenKnight;
-(NSMutableArray*) resolveChains;

-(NSMutableArray*) resolveChainsAll;
//resolves all chains working back, even if they are short

-(void) addToIdentitiesUsingChains: (NSMutableArray*) chains
                     resolvingEnds: (BOOL) resolvingEnds;

-(int) determineFirstKnightInTaggedChain: (TaggedChain*) taggedChain
                  persistWithShortChains: (BOOL) persist;
    //this function trims the givenchain, then uses the next recursive function
-(int) determineFirstKnightIn: (NSMutableArray*) chain;
-(void) setPerson: (int) p to: (int) IDENT;
//pursues knock-on consequences. Don't bother with it if there won't be any
-(NSMutableArray*) identities;
//can be useful to directly call methods. Then need to extract identities;

@end
