//  SpiderInterrogator.m
//  KnightsAndSpies

int UNKNOWNSPIDER = -1;

#import "SpiderInterrogator.h"
//#define DEBUG don't uncommment, it causes a run time crash
//#include "NSLogD.c"


@implementation SpiderInterrogator

-(SpiderInterrogator*) initWithCrowdSpider: (Crowd*) givenCrowd
{
    self = [super init];
    crowd = givenCrowd; //Not copied
                        //NSLog(@"initWithCrowd here, just set weights = %@",weights);
                        //NSLog(@"crowd = %@",crowd);[crowd showMembers];
    return self;
}

-(NSDictionary*) determineIdentitiesAcceptingAt: (int) l
{
    //NSLog(@"SpiderInterrogator.determineIdentities here, target votes = %i",l);
//#ifdef DEBUG
 //   [crowd showMembers];
//#endif
    
    int n = [crowd numberOfPeople];
    
    //NSLog(@"First phase");
    int m; //m keeps track of the person we're asking about
    int r=0; //r is the next person to ask about person m

    NSMutableArray* spiders = [[NSMutableArray alloc] init];

    BOOL foundKnight = FALSE;

    while (foundKnight == FALSE)
    {
        m = r; r= r+1;
        //NSLog(@"Starting a new search for a knight, m = %i, r = %i",m,r);
        int votesfor = 1; //the person will vote for themselves (if asked), we assume
        int votesagainst = 0;
        Spider* spider = [[Spider alloc] initWithPerson: m];
        [spiders addObject: spider];
        //NSLog(@"Started a new spider, %@",spider);
        
        while ((votesfor > votesagainst) && (votesfor < l)) { //test first, as its possible l=1
            //NSLog(@"About to ask person %i about person %i",r,m);
            int view = [[[crowd person: r] viewOnPerson: m] intValue];
            if (view==SPY) {
                //NSLog(@"Person %i claims that person %i is a spy",r,m);
                [spider addVoteAgainst: r];
                votesagainst += 1;
            }
            else if (view==KNIGHT) {
                //NSLog(@"Person %i claims that person %i is a knight",r,m);
                [spider addVoteFor: r];
                votesfor += 1;
            }
            else NSLog(@"ERROR: view of person %i on person %i was undefined",r,m);
            r = r+1;
        }        
        

        //NSLog(@"Finished with person %i; votesfor = %i, votesagainst = %i",m,votesfor,votesagainst);
        if (votesfor == l) {
            //NSLog(@"They should be a knight");
            foundKnight = TRUE;
        }
        else {
            //NSLog(@"They are rejected");
        }
        //NSLog(@"spider = %@",spider);

        //need to update the target votes l
        l = l - votesagainst;
        //NSLog(@"Now will accept at %i votesfor",l);
    }

    //NSLog(@"Second phase: Person %i should be a knight",m);
    Person* knight = [crowd person: m];
    
    NSMutableArray* identities = [[NSMutableArray alloc] init];
    int i; for (i=0;i<[crowd numberOfPeople];i++) {
        [identities addObject: [NSNumber numberWithInt: UNKNOWNSPIDER]];
    }
    int questionsToKnight = 0;
    int questionsSaved = 0;
    int p = 0; //by end p will be the number of the first person we haven't asked about / asked
    
    for (i=0;i<[spiders count];i++) {
        //the last spider needs to be treated a little differently
        Spider* spider = [spiders objectAtIndex: i];
        //NSLog(@"Now resolving spider %i",i);
        //NSLog(@"%@",spider);

        int r = [spider person];
        int view; //will be the knights view on this spider centre
        NSMutableArray* votersFor = [spider votesFor];
        NSMutableArray* votersAgainst = [spider votesAgainst];
        p = p + [votersFor count] + [votersAgainst count] + 1;

        if (i < [spiders count]-1) {
            view = [[knight viewOnPerson: r] intValue];
            questionsToKnight += 1;
            //NSLog(@"Found out view of knight on person %i (1 question)",r);
        }
        else { //now dealing with the last spider which has our known knight at the centre
            view = KNIGHT;
        }
            
        if (view==KNIGHT) {
            [identities replaceObjectAtIndex: r withObject: [NSNumber numberWithInt: KNIGHT]];
            //NSLog(@"Just made spider centre person %i a knight",r);
            //votersAgainst are definitely spies, we save one question in this case, unless in final spider
            if (i < [spiders count]-1) {
                questionsSaved += 1;
                //NSLog(@"Will save one question: questionsSaved is now %i",questionsSaved);
            }
            int j; for (j=0;j<[votersAgainst count];j++) {
                int knownSpy = [[votersAgainst objectAtIndex: j] intValue];
                [identities replaceObjectAtIndex: knownSpy withObject: [NSNumber numberWithInt: SPY]];
                //NSLog(@"Just made accuser %i a spy",knownSpy);
            }
            //votersFor could be knights or spies
            int k; for (k=0;k<[votersFor count];k++) {
                int unknown = [[votersFor objectAtIndex: k] intValue];
                int view2 = [[knight viewOnPerson: unknown] intValue];
                questionsToKnight += 1;
                if (view2 == KNIGHT) { //so a knight was supported by a knight
                    [identities replaceObjectAtIndex: unknown withObject:
                        [NSNumber numberWithInt: KNIGHT]];
                    //NSLog(@"Just made supporter %i a knight (1 question)",unknown);
                }
                else {
                    [identities replaceObjectAtIndex: unknown withObject:
                        [NSNumber numberWithInt: SPY]];
                    //NSLog(@"Just made supporter %i a spy (1 question)",unknown);
                }
            }
        }
        else { //so the centre of the spider is a SPY
            [identities replaceObjectAtIndex: r withObject: [NSNumber numberWithInt: SPY]];
            //NSLog(@"Just made spider centre person %i a spy",r);
            //votersFor are definitely spies
            int j; for (j=0;j<[votersFor count];j++) {
                int knownSpy = [[votersFor objectAtIndex: j] intValue];
                [identities replaceObjectAtIndex: knownSpy withObject: [NSNumber numberWithInt: SPY]];
                //NSLog(@"Just made supporter %i a spy",knownSpy);
            }
            //votersAgainst could be knights or spies
            int k; for (k=0;k<[votersAgainst count];k++) {
                int unknown = [[votersAgainst objectAtIndex: k] intValue];
                int view2 = [[knight viewOnPerson: unknown] intValue];
                questionsToKnight +=1;
                if (view2 == KNIGHT) { //so a spy was accused by a knight
                    [identities replaceObjectAtIndex: unknown withObject:
                        [NSNumber numberWithInt: KNIGHT]];
                    //NSLog(@"Just made accuser %i a knight (1 question)",unknown);
                }
                else {
                    [identities replaceObjectAtIndex: unknown withObject:
                        [NSNumber numberWithInt: SPY]];
                    //NSLog(@"Just made accuser %i a spy (1 question)",unknown);
                }
            }
        }
    }

    //we also need to ask about any people that aren't in a spider, i.e. people m+1 .. n-1
    //NSLog(@"Person %i should be first unencountered so far",p);
    int j; for (j=p;j<n;j++) {
        int view = [[knight viewOnPerson: j] intValue];
        questionsToKnight +=1;
        if (view == KNIGHT) { //so a spy was accused by a knight
            [identities replaceObjectAtIndex: j withObject:
                [NSNumber numberWithInt: KNIGHT]];
            //NSLog(@"Just made person %i a KNIGHT (1 question)",j);
        }
        else {
            [identities replaceObjectAtIndex: j withObject:
                [NSNumber numberWithInt: SPY]];
            //NSLog(@"Just made person %i a SPY (1 question)",j);
        }
    }
    
    return [NSDictionary dictionaryWithObjectsAndKeys: identities, @"identities",
        [NSNumber numberWithInt: questionsToKnight], @"questionsToKnight",
        [NSNumber numberWithInt: questionsSaved], @"questionsSaved", nil];
}

@end
